function rhrCreateWindow()
	rhr.Window:SetPoint("TOPLEFT", UIParent, "TOPLEFT", rhrValues.locmainx, rhrValues.locmainy)
	rhr.Window:SetHeight(rhrValues.mainheight)
	rhr.Window:SetWidth(rhrValues.mainwidth)
	rhr.WindowFrameTop:SetTexture("RiftHealer", "Textures/header.png")
	rhr.WindowFrameTop:SetPoint("TOPLEFT", rhr.Window, "TOPLEFT", 0, 0)
	rhr.WindowFrameTop:SetPoint("TOPRIGHT", rhr.Window, "TOPRIGHT", 0, 0)
	rhr.WindowFrameTop:SetHeight(30)

	rhr.WindowDrag:SetPoint("TOPLEFT", rhr.WindowFrameTop, "TOPLEFT")
	rhr.WindowDrag:SetPoint("TOPRIGHT", rhr.WindowFrameTop, "TOPRIGHT")
	rhr.WindowDrag:SetHeight(40)
	rhr.CenterFrame:SetPoint("TOPLEFT", rhr.WindowFrameTop, "BOTTOMLEFT", 0, 20)
	rhr.CenterFrame:SetPoint("BOTTOMRIGHT", rhr.Window, "BOTTOMRIGHT", 0, 0)
	rhr.CenterFrame:SetLayer(1)
	

	rhr.OptionsButton:SetTexture("RiftHealer", "Textures/options.png")
	rhr.OptionsButton:SetWidth(24)
	rhr.OptionsButton:SetHeight(24)
	rhr.OptionsButton:SetLayer(2)
	rhr.OptionsButton:SetPoint("TOPLEFT", rhr.Window, "TOPLEFT", 0, 4)
	rhr.LockButton:SetTexture("RiftHealer", "Textures/lock.png")
	rhr.LockButton:SetWidth(24)
	rhr.LockButton:SetHeight(24)
	rhr.LockButton:SetLayer(2)
	rhr.LockButton:SetPoint("TOPLEFT", rhr.OptionsButton, "TOPRIGHT", 0, 0)
	rhr.CloseButton:SetTexture("RiftHealer", "Textures/close.png")
	rhr.CloseButton:SetWidth(24)
	rhr.CloseButton:SetHeight(24)
	rhr.CloseButton:SetLayer(2)
	rhr.CloseButton:SetPoint("TOPRIGHT", rhr.Window, "TOPRIGHT", 0, 4)
	rhr.TTButton:SetTexture("RiftHealer", "Textures/tooltip.png")
	rhr.TTButton:SetWidth(24)
	rhr.TTButton:SetHeight(24)
	rhr.TTButton:SetLayer(2)
	rhr.TTButton:SetPoint("TOPRIGHT", rhr.CloseButton, "TOPLEFT", 0, 0)
	rhr.ResizeButton:SetTexture("RiftHealer", "Textures/resizer.png")
	rhr.ResizeButton:SetWidth(32)
	rhr.ResizeButton:SetHeight(32)
	rhr.ResizeButton:SetLayer(3)
	rhr.ResizeButton:SetPoint("BOTTOMRIGHT", rhr.CenterFrame, "BOTTOMRIGHT", 0, 0)
	
	rhrCreateGroups()
	toggleLockedWindow(rhrValues.islocked)
	
	function rhr.CloseButton.Event.LeftClick()
		if not rhrValues.isincombat then
			rhrHideWindow()
			rhr.WindowOptions:SetVisible(false)
		end
	end
	function rhr.CloseButton.Event:MouseIn()
		if not rhrValues.isincombat then
			rhr.CloseButton:SetTexture("RiftHealer", "Textures/closein.png")
		end
	end
	function rhr.CloseButton.Event:MouseOut()
		if not rhrValues.isincombat then
			rhr.CloseButton:SetTexture("RiftHealer", "Textures/close.png")
		end
	end
	function rhr.LockButton.Event.LeftClick()
		if not rhrValues.isincombat then
			if rhrValues.islocked then
				rhrValues.islocked = false
			else
				rhrValues.islocked = true
			end
			toggleLockedWindow(rhrValues.islocked)
		end
	end
	function rhr.LockButton.Event:MouseIn()
		if not rhrValues.isincombat then
			if not rhrValues.islocked  then
				rhr.LockButton:SetTexture("RiftHealer", "Textures/lockin.png")
			else
				rhr.LockButton:SetTexture("RiftHealer", "Textures/lockedin.png")
			end
		end
	end
	function rhr.LockButton.Event:MouseOut()
		if not rhrValues.isincombat then
			if not rhrValues.islocked then
				rhr.LockButton:SetTexture("RiftHealer", "Textures/lock.png")
			else
				rhr.LockButton:SetTexture("RiftHealer", "Textures/locked.png")
			end
		end
	end
	function rhr.OptionsButton.Event.LeftClick()
		if not rhrValues.isincombat then
			if rhr.WindowOptions:GetVisible() then
				rhr.WindowOptions.Event.Close()
			else
				rhr.WindowOptions:SetVisible(true)
				rhr.WindowOptionsSetTab:SetActiveTab(rhrValues.set)
			end
		end
	end
	function rhr.OptionsButton.Event:MouseIn()
		if not rhrValues.isincombat then
			rhr.OptionsButton:SetTexture("RiftHealer", "Textures/optionsin.png")
		end
	end
	function rhr.OptionsButton.Event:MouseOut()
		if not rhrValues.isincombat then
			rhr.OptionsButton:SetTexture("RiftHealer", "Textures/options.png")
		end
	end
	
		
--	function rhr.PetButton.Event.LeftClick()
--		if not rhrValues.isincombat then
--			if rhrValues.pet then
--				rhrValues.pet = false
--				petfound = false  
--				rhr.PetButton:SetTexture("RiftHealer", "Textures/petoffin.png")
--			else
--				rhrValues.pet = true
--				petfound = true 
--				rhr.PetButton:SetTexture("RiftHealer", "Textures/petonin.png")
--			end
--		end
--	end
	function rhr.TTButton.Event.LeftClick()
		if not rhrValues.isincombat then
			if rhrValues.showtooltips then
				rhrValues.showtooltips = false
				processMacroText(rhr.UnitsTable)
				rhr.TTButton:SetTexture("RiftHealer", "Textures/tooltipoffin.png")
			else
				rhrValues.showtooltips = true
				processMacroText(rhr.UnitsTable)
				rhr.TTButton:SetTexture("RiftHealer", "Textures/tooltipin.png")
			end
		end
	end
	function rhr.TTButton.Event:MouseIn()
		if not rhrValues.isincombat then
			if rhrValues.showtooltips then
				rhr.TTButton:SetTexture("RiftHealer", "Textures/tooltipin.png")
			else
				rhr.TTButton:SetTexture("RiftHealer", "Textures/tooltipoffin.png")
			end
		end
	end
	function rhr.TTButton.Event:MouseOut()
		if not rhrValues.isincombat then
			if rhrValues.showtooltips then
				rhr.TTButton:SetTexture("RiftHealer", "Textures/tooltip.png")
			else
				rhr.TTButton:SetTexture("RiftHealer", "Textures/tooltipoff.png")
			end
		end
	end
	windowdragActive = false
	windowResizeActive = false

	function rhr.WindowDrag.Event:LeftDown()
		if not rhrValues.islocked then
			windowdragActive = true
			local mouseStatus = Inspect.Mouse()
			rhr.clickOffset["x"] = mouseStatus.x - rhrValues.locmainx
			rhr.clickOffset["y"] = mouseStatus.y - rhrValues.locmainy
		end
	end
	function rhr.WindowDrag.Event:LeftUp()
		windowdragActive = false
	end
	function rhr.WindowDrag.Event:LeftUpoutside()
		windowdragActive = false
	end
	function rhr.WindowDrag.Event:MouseMove(x,y)
		if windowdragActive == true then
			rhrValues.locmainx = x - rhr.clickOffset["x"]
			rhrValues.locmainy = y - rhr.clickOffset["y"]	
			rhr.Window:SetPoint("TOPLEFT", rhr.Context, "TOPLEFT", rhrValues.locmainx, rhrValues.locmainy)
		end
	end
	function rhr.ResizeButton.Event:LeftDown()
		if not rhrValues.islocked then
			windowResizeActive = true
			local mouseStatus = Inspect.Mouse()
			rhr.clickOffset["x"] = mouseStatus.x
			rhr.clickOffset["y"] = mouseStatus.y
			rhr.resizeOffset["x"] = rhrValues.mainwidth
			rhr.resizeOffset["y"] = rhrValues.mainheight
		end
	end
	function rhr.ResizeButton.Event:LeftUp()
		windowResizeActive = false
		rhrValues.mainwidth = rhr.Window:GetWidth()
		rhrValues.mainheight = rhr.Window:GetHeight()
	end
	function rhr.ResizeButton.Event:MouseIn()
		if not rhrValues.islocked then
			rhr.ResizeButton:SetTexture("RiftHealer", "Textures/resizerin.png")
		end
	end
	function rhr.ResizeButton.Event:MouseOut()
		rhr.ResizeButton:SetTexture("RiftHealer", "Textures/resizer.png")
	end
	function rhr.ResizeButton.Event:LeftUpoutside()
		windowResizeActive = false
	end
	function rhr.ResizeButton.Event:MouseMove(x,y)
		if windowResizeActive == true then
			
			rhr.Window:SetWidth(math.ceil(rhr.resizeOffset["x"] + (x - rhr.clickOffset["x"])))
			rhr.Window:SetHeight(math.ceil(rhr.resizeOffset["y"] + (y - rhr.clickOffset["y"])))
			rhrCreateGroups()
		end
	end

	if rhrValues.windowstate then rhr.Window:SetVisible(true) end
	if not rhrValues.windowstate then print ("Rift Healer is currently closed, '/rhr show' to open") end

	end
	
function rhrCreateGroups()
	tempx = (math.ceil((rhr.Window:GetWidth() - 24) /4))
	tempy = (math.ceil((rhr.Window:GetHeight() - 60) / 5))

	for a = 1, 4 do
		for i = 1, 5 do
			var = i + ((a-1) * 5)
			rhr.groupBF[var]:SetTexture("RiftHealer", "Textures/backframe.png")
			rhr.groupBF[var]:SetLayer(0)
			rhr.groupBF[var]:SetBackgroundColor(0, 0, 0, .5)
			rhr.groupBF[var]:SetPoint("TOPLEFT", rhr.CenterFrame, "TOPLEFT", tempx * (a - 1) + (a * 4),  tempy * (i - 1))
			rhr.groupBF[var]:SetHeight(tempy)
			rhr.groupBF[var]:SetWidth(tempx)
			rhr.groupBF[var]:SetVisible(not rhrValues.islocked)

			rhr.groupHF[var]:SetTexture("RiftHealer", "Textures/"..rhrValues.texture)
			rhr.groupHF[var]:SetPoint("TOPLEFT", rhr.groupBF[var], "TOPLEFT", 5,  2 )
			rhr.groupHF[var]:SetHeight(tempy - 5)
			rhr.groupHF[var]:SetWidth(tempx - 10)
			rhr.groupHF[var]:SetLayer(1)
		
			rhr.groupName[var]:SetPoint("TOPLEFT", rhr.groupBF[var], "TOPLEFT", 24, 3)
			rhr.groupName[var]:SetLayer(2)
			rhr.groupName[var]:SetFontSize(rhrValues.font)
			rhr.groupName[var]:SetText(rhr.UnitsTable[var])

			rhr.groupStatus[var]:SetText("100%")
			rhr.groupStatus[var]:SetFontColor(rhrCallingColors[5].r, rhrCallingColors[5].g, rhrCallingColors[5].b, 1)
			rhr.groupStatus[var]:SetLayer(2)
			rhr.groupStatus[var]:SetPoint("TOPRIGHT", rhr.groupBF[var], "TOPRIGHT", -10, tempy /2)

			rhr.groupRole[var]:SetTexture("RiftHealer", "Textures/blank.png")
			rhr.groupRole[var]:SetPoint("TOPLEFT", rhr.groupBF[var], "TOPLEFT", 6,  6 )
			rhr.groupRole[var]:SetHeight(16)
			rhr.groupRole[var]:SetWidth(16)
			rhr.groupRole[var]:SetLayer(2)
		
			rhr.groupHoT[var]:SetTexture("RiftHealer", "Textures/buffhot.png")
			rhr.groupHoT[var]:SetPoint("TOPRIGHT", rhr.groupBF[var], "TOPRIGHT", -6,  6 )
			rhr.groupHoT[var]:SetHeight(16)
			rhr.groupHoT[var]:SetWidth(16)
			rhr.groupHoT[var]:SetLayer(2)
			rhr.groupHoT[var]:SetVisible(false)
		
			rhr.groupMask[var]:SetLayer(3)
			rhr.groupMask[var]:SetBackgroundColor(0,0,0,0)
			rhr.groupMask[var]:SetPoint("TOPLEFT", rhr.CenterFrame, "TOPLEFT", tempx * (a - 1) + (a * 4),  tempy * (i - 1))
			rhr.groupMask[var]:SetHeight(tempy)
			rhr.groupMask[var]:SetWidth(tempx)
			rhr.groupMask[var]:SetVisible(false)

		end
	end
	processMacroText(rhr.UnitsTable)
	for var = 1,20 do
		rhr.groupTooltip[var]:InjectEvents(rhr.groupMask[var], function() return rhr.groupText[var] end)
	end
	if tempx <  95 then
		size = tempx / 4
		rhrValues.font = math.ceil(tempx / 6)
	else
		size = 24
		rhrValues.font = 16
	end
		rhr.OptionsButton:SetWidth(size)
		rhr.LockButton:SetWidth(size)
		rhr.TTButton:SetWidth(size)
		rhr.CloseButton:SetWidth(size)
end

	rhr.WindowReset:SetPoint("CENTER", UIParent, "CENTER")
	rhr.WindowReset:SetTitle("Reset")
	rhr.WindowReset:SetWidth(250)
	rhr.WindowReset:SetHeight(200)

	rhr.WindowResetText:SetPoint("TOPLEFT", rhr.WindowReset, "TOPLEFT", 25, 50)
	rhr.WindowResetText:SetWidth(200)
	rhr.WindowResetText:SetWordwrap(true)
	rhr.WindowResetText:SetHeight(100)
	rhr.WindowResetText:SetText("All window positions and variables have been reset to default. Click Continue to reload the addon and complete the process.")
	
	rhr.WindowResetButton:SetPoint("CENTER", rhr.WindowReset, "CENTER", 0, 50)
	rhr.WindowResetButton:SetWidth(150)
	rhr.WindowResetButton:SetHeight(50)
	rhr.WindowResetButton:SetText("CONTINUE")
	rhr.WindowResetButton.Event.LeftClick = "/reloadui"
	
	
	